#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "slimopt.h"

int main (int argc, char **argv)
{
	int err;
    int next_arg_idx;
    enum opt{
        OPT_f = 0,
        OPT_b,
        OPT_a,
        OPT_d,
        OPT_c,
        OPT_num,
    };
    void *opt_val[OPT_num];
    static const OPTSPEC opt_tbl[] ={ 
        {'f',  OPT_STR, NULL},            /* string defaut is NULL */
        {'b',  OPT_FLG, (void *)0},       /* flag default false */
        {'a',  OPT_STR, (void *)"foo"},   /* string default is "foo" */
        {'d',  OPT_FLG, (void *)0},       /* flag default false */
        {'\0', OPT_FLG, (void *)0},       /* terminater */
    };
    
	err = slimopt(argc, argv, opt_tbl,opt_val, &next_arg_idx);
	fprintf(stdout, 
			"slimopt returns err=%d, next_arg[%d]=%s\n",
			err, next_arg_idx, argv[next_arg_idx]);
	switch(err) {
	case -1: /* missing argument */
		fprintf(stdout, "missing argument\n");
		return 0;
	case -2: /* unmathed with the defined options */
		fprintf(stdout, "unmathed with the defined options\n");
		return 0;
	case -3: /* type error : spec table is illegal */
		fprintf(stdout, "spec table is illegal\n");
		return 0;
	}
	
	/* example refering the option flag */
    if ((int)opt_val[OPT_b] != 0) {   /* cast (int) on opt_val */
		fprintf(stdout, "OPT_b is true\n");
	} else {
		fprintf(stdout, "OPT_b is false\n");
	}

    if ((int)opt_val[OPT_d] != 0) {
		fprintf(stdout, "OPT_d is true\n");
	} else {
		fprintf(stdout, "OPT_d is false\n");
	}

	/* example refering the option string */
    if ((void *)opt_val[OPT_f] == NULL) {
		fprintf(stdout, "OPT_f is NULL\n");
	} else {
		fprintf(stdout, "OPT_f is %s\n", (char *)opt_val[OPT_f]);
	}

    if ((void *)opt_val[OPT_a] == NULL) {
		fprintf(stdout, "OPT_a is NULL\n");
	} else {
		fprintf(stdout, "OPT_a is %s\n", (char *)opt_val[OPT_a]);
	}

	return 0;
}

/* end of sampl_opt.c */
