#!/bin/sh
echo "\ntest1: Multiple options ./sample_opt -b -d"
./sample_opt -b -d

echo "\ntest2: Multiple options with a hyphen delimiter in a single token"
echo "./sample_opt -bd"
./sample_opt -bd
echo "./sample_opt -db"
./sample_opt -db
 
echo "\ntest3: Option with whitespace separating"
echo "./sample_opt -f abc"
./sample_opt -f abc
echo "\ntest4: Option without whitespace separating"
echo "./sample_opt -fabc"
./sample_opt -fabc

echo "\ntest5: Options can precede other non-option arguments."
echo "./sample_opt -bdf abc"
./sample_opt -bdf abc
echo "./sample_opt -bdfabc"
./sample_opt -bdfabc

echo "\ntest6: The argument ‘--’ terminates all options"
echo "./sample_opt -f abc -- -b -d"
./sample_opt -f abc -- -b -d

echo "\ntest7: A single hyphen is interpreted as non-option argument." 
echo "./sample_opt -f abc - -b -d"
./sample_opt -f abc - -b -d

echo "\ntest8: Options may be supplied in any order, or appear multiple times."
echo "The interpretation is selected from the most right side assignment." 
echo "./sample_opt -f abc -fdef -bdfghi"
./sample_opt -f abc -fdef -bdfghi

echo "\ntest9: When used the udefined option, error will be returned."
echo "./sample_opt -f abc -x def"
./sample_opt -f abc -x def

echo "\ntest10: When found non-option parameter, this routine will exit."
echo "./sample_opt -f abc foo.txt"
./sample_opt -f abc foo.txt

